<?xml version="1.0" encoding="windows-1250"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format">

  <xsl:template match="/">
    <fo:root>
      <!-- Definice layoutu strnky -->
      <fo:layout-master-set>
        <!-- Rozmry strnky a jej okraje -->
        <fo:simple-page-master master-name="page"
                               page-height="297mm" 
                               page-width="210mm" 
                               margin="1in">
          <!-- Tiskov zrcadlo - oblast pro samotn obsah strnky -->
          <fo:region-body margin-bottom="15mm"/>        
          <!-- Oblast pro patu strnky -->
          <fo:region-after extent="10mm"/>
        </fo:simple-page-master>
      </fo:layout-master-set>

      <!-- Definice obsahu strnky -->
      <fo:page-sequence master-name="page">
        <!-- Spolen obsah vech strnek v pat strnky -->
        <fo:static-content flow-name="xsl-region-after">
          <fo:block>
            <!-- slo strany na kad strnce -->
            <xsl:text>Strana </xsl:text>
            <fo:page-number/>
          </fo:block>
        </fo:static-content>
        <!-- Samotn text dokumentu -->
        <fo:flow flow-name="xls-region-body">
          <!-- Zpracovn vech element zdrojovho dokumentu -->
          <xsl:apply-templates/>
	  <xsl:apply-templates select="clanek/zahlavi/autor"/>
        </fo:flow>
      </fo:page-sequence>
    </fo:root>
  </xsl:template>
  
  <!-- ablona pro zhlav lnku -->
  <xsl:template match="zahlavi">
    <fo:block text-align="center" space-before="20pt"
              space-after="14pt" font-family="Helvetica">
      <xsl:apply-templates select="rubrika"/>
      <xsl:apply-templates select="nazev"/>
    </fo:block>
  </xsl:template>
  
  <!--ablona pro rubriku -->
  <xsl:template match="rubrika">
    <fo:block font-size="6pt" text-align="end">
      <xsl:text>Rubrika: </xsl:text>
      <fo:inline font-weight="bold">
        <xsl:apply-templates/>
      </fo:inline>
    </fo:block>
  </xsl:template>

  <!--ablona pro nzev lnku -->
  <xsl:template match="nazev">
    <fo:block font-size="24pt" font-weight="bold" space-before="6pt"
              space-after="4pt">
      <xsl:apply-templates/>
    </fo:block>
  </xsl:template>

  <!--ablona pro autora lnku -->
  <xsl:template match="autor">
    <fo:block font-style="italic" text-align="end" space-before="6pt">
      <xsl:text>&#x2014; </xsl:text>
      <xsl:apply-templates/>
      <xsl:text> &#x2014; </xsl:text>
    </fo:block>
  </xsl:template>

  <!--ablona pro perex -->
  <xsl:template match="perex">
    <fo:block text-align="justify" font-style="italic" font-weight="bold">
      <xsl:apply-templates/>
    </fo:block>
  </xsl:template>

  <!--ablona pro odstavec -->
  <xsl:template match="para">
    <fo:block text-indent="20pt" text-align="justify">
      <xsl:apply-templates/>
    </fo:block>
  </xsl:template>

  <!--ablona pro zvraznn -->
  <xsl:template match="em">
    <fo:inline font-style="italic">
      <xsl:apply-templates/>
    </fo:inline>
  </xsl:template>

</xsl:stylesheet>
