<?xml version="1.0" encoding="windows-1250"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- Vstup bude do WML v kdovn UTF-8 -->
  <xsl:output method="xml" encoding="utf-8" indent="yes" 
              doctype-public="-//WAPFORUM//DTD WML 1.1//EN"
              doctype-system="http://www.wapforum.org/DTD/wml_1.1.xml"/> 

  <!-- Zpracovn lnku -->
  <xsl:template match="/clanek">
    <wml>
      <!-- Tlatko Zpt bude na kad kart -->
      <template>
        <do type="prev">
          <prev/>
        </do>
      </template>
      
      <!-- vodn karta s nzvem lnku -->
      <card>
        <!-- Tlatko pro pechod na prvn odstavec lnku -->
        <do type="accept" label="Dal">
          <go href="#perex"/>
        </do>
        <p align="center">
          <big><xsl:value-of select="zahlavi/nazev"/></big></p>
        <p align="center"><i><xsl:value-of select="zahlavi/autor"/></i></p>
        <p align="right">
          Rubrika: <b><xsl:value-of select="zahlavi/rubrika"/></b>
        </p>
      </card>   

      <!-- Prvn odstavec lnku -->
      <card id="perex">
        <!-- Tlatko pro pechod na dal odstavec lnku -->
        <do type="accept" label="Dal">
          <go href="#no1"/>
        </do>
        <p><xsl:value-of select="perex"/></p>
      </card>

      <!-- Zpracovn vech odstavc -->
      <xsl:for-each select="para">
        <!-- Vygenerovn jedinenho id kad karty -->
        <xsl:element name="card">
          <xsl:attribute name="id">no<xsl:number 
            value="position()" format="1"/></xsl:attribute>
          <!-- U vech odstavc krom poslednho vygenerujeme tlatko
               pro pechod na dal kartu -->
          <xsl:if test="position()!=last()">
            <do type="accept" label="Dal">
              <xsl:element name="go">
                <xsl:attribute name="href">#no<xsl:number
                  value="position()+1" format="1"/></xsl:attribute>
              </xsl:element>
            </do>
          </xsl:if>
          <!-- Na obsah odstavce aplikujeme dal ablony,
               nap. pro zvraznn psma <em>...</em> -->
          <p><xsl:apply-templates select="."/></p>
        </xsl:element>
      </xsl:for-each>
    </wml>
  </xsl:template>

  <!-- Zvraznn psma -->
  <xsl:template match="em">
    <i><xsl:apply-templates/></i>
  </xsl:template>

</xsl:stylesheet>