<?xml version="1.0" encoding="windows-1250"?>
<xsl:stylesheet	version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- Vstup bude do HTML v kdovn ISO Latin 2 -->
  <xsl:output method="html" encoding="iso-8859-2"/>  

  <!-- Zpracovn celho dokumentu, koenov element vygeneruje
       kostru HTML dokumentu -->
  <xsl:template match="/">
    <html>
      <head>
	<title>Seznam odkaz</title>
      </head>
      <body>
	<xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>

  <!-- Nadpis kapitoly se objev v HTML strnce -->
  <xsl:template match="chapter/title">
    <h1><xsl:value-of select="."/></h1>
  </xsl:template>

  <!-- Nadpis podkapitoly -->
  <xsl:template match="chapter/section/title">
    <xsl:if test="..//ulink">
      <!-- se objev jen pokud podkapitola obsahuje njak odkaz -->
      <h2><xsl:value-of select="."/></h2>
    </xsl:if>
  </xsl:template>

  <!-- Z odkazu ulink vytvome <a href="...">...</a> -->
  <xsl:template match="ulink">
    <!-- Vygenerovn elementu a -->
    <xsl:element name="a">
      <!-- Pidn atributu href -->
      <xsl:attribute name="href">
	<!-- Vloen URL adresy z elementu ulink -->
	<xsl:value-of select='@url'/>
      </xsl:attribute>
      <xsl:value-of select="."/>
    </xsl:element>
    <br/>
  </xsl:template>

  <!-- Ostatn text dokumentu budeme ignorovat -->
  <xsl:template match="text()">
  </xsl:template>

</xsl:stylesheet>